Summary: Compiler tools for the CRIS CPU in Axis ETRAX chips.
# $Id: cris-dist.spec,v 1.10 2001/08/09 09:31:19 hp Exp $

%define name cris-dist
%define version 1.14
%define serial 35

Vendor: Axis Communications AB.
License: GNU General Public License, libraries with GNU Library General Public License
Name: %{name}
Version: %{version}
Release: 1

# It seems considered bad to have a "serial" version number, but
# we don't need to *rely* on it right now.  We put the N in RN
# for the gcc-cris version there in case we will ever need it
# by itself.
Serial: %{serial}

# These paths are what corrsponds to the defaults in
# install-cris-tools (with _prefix=/usr), so we want them to be
# the default, to minimize differences to installing from the
# .tar.gz distribution.  Note that this package is not
# relocateable.  It does have the prefix and individual
# directories compile-time configurable though, so all you need
# is the source RPM or the original tarballs and an extra hour
# or two.
%define installinfo_ %(which install-info)
%define libdir_ %{_prefix}/local/cris/lib
%define bindir_ %{_prefix}/local/cris
%define mandir_ %{_prefix}/local/man/man1
%define infodir_ %{_prefix}/local/info
%define pkg0 %{name}-%{version}
%define pkg1 %{name}-glibc-%{version}
%define pkg2 %{name}-elinux-headers-%{version}
%define pkg3 %{name}-linux-headers-%{version}
%define make_ make
%define makeinfo_ makeinfo

Group: Development/Tools
Source: ftp://ftp.axis.se/pub/axis/tools/cris/compiler-kit/%{pkg0}.tar.gz

# If you find there is problems building glibc, and you don't
# need glibc installed, try any of killing the "glibc", "linux-headers" or
# "elinux-headers" directories and the installation script should cope.
Source1: ftp://ftp.axis.se/pub/axis/tools/cris/compiler-kit/%{pkg1}.tar.gz
Source2: ftp://ftp.axis.se/pub/axis/tools/cris/compiler-kit/%{pkg2}.tar.gz
Source3: ftp://ftp.axis.se/pub/axis/tools/cris/compiler-kit/%{pkg3}.tar.gz

URL: http://developer.axis.com/
Packager: Compiler contact <compiler-contact@axis.com>

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Requires: perl >= 5.004

# There should be a source-specific "Source-requires".  We would make use
# of it because glibc requires make >= 3.79 when *building* it.  Requiring
# it for use of this binary package is nonsensical.
#Requires: make >= 3.79
# Ditto makeinfo.
#Requires: makeinfo >= 4

%description
This toolsuite contains ports of GCC (gcc-cris release R%{serial}),
binutils (post 2.11), newlib (post 1.8.2) and glibc (April 2001) for the
CRIS CPU core in Axis Communications ETRAX chips.  It is used to build all
ETRAX-targeted software.  For details, see
%{_defaultdocdir}/%{pkg0}/README and %{_defaultdocdir}/%{pkg0}/NEWS
(file paths may vary).

%prep
# Test version of "make".  We re-use scraps from glibc.  Remember to
# update or sync for "GNU make 4.?" and "GNU makeinfo [5-9]".
# See "Requires:" section above for why we don't just make this a
# "requires".
echo 'Checking version of "make":'
ac_prog_version=`%{make_} --version 2>&1 | sed -n 's/^.*GNU Make[^0-9]*\([0-9][0-9.]*\).*$/\1/p'`
case $ac_prog_version in
  '') ac_prog_version="v. ?.??, bad"; ac_verc_fail=yes;;
  3.79* | 3.[89]*)
     ac_prog_version="$ac_prog_version, ok"; ac_verc_fail=no;;
  *) ac_prog_version="$ac_prog_version, bad"; ac_verc_fail=yes;;
esac
echo Version of make is "$ac_prog_version"
if test $ac_verc_fail = yes
then
  echo '*** That "make" is unusable for building this source package.'
  echo '*** Upgrade to GNU make version 3.79 or newer.'
  exit 1
fi
echo 'Checking version of "makeinfo":'
ac_prog_version=`%{makeinfo_} --version 2>&1 | sed -n 's/^.*GNU texinfo.* \([0-9][0-9.]*\).*$/\1/p'`
case $ac_prog_version in
  '') ac_prog_version="v. ?.??, bad"; ac_verc_fail=yes;;
  4.*)
     ac_prog_version="$ac_prog_version, ok"; ac_verc_fail=no;;
  *) ac_prog_version="$ac_prog_version, bad"; ac_verc_fail=yes;;
esac
echo Version of makeinfo is "$ac_prog_version"
if test $ac_verc_fail = yes
then
  echo '*** That "makeinfo" is unusable for building this source package.'
  echo '*** Upgrade to GNU texinfo version 4.0 or newer.'
  exit 1
fi
rm -rf $RPM_BUILD_ROOT
%setup
%setup1 -T -D -a 1
%setup2 -T -D -a 2
%setup3 -T -D -a 3


%build
echo Building is not a separate step.


# We delete "dir" so we can just list the directories and have
# below it everything neatly indexed for installation.  This
# does not work if $RPM_BUILD_ROOT is "/", but we would never
# get here if that happens.  We have to remove directories which
# are subdirectories of each other else rpm will complain.
# Note that %{infodir_} contains a leading slash.
%install
./install-cris-tools %{libdir_} %{bindir_} %{mandir_} %{infodir_} $RPM_BUILD_DIR/%{pkg0}/tmpdir $RPM_BUILD_ROOT </dev/null
echo > $RPM_BUILD_DIR/%{pkg0}/%{pkg0}-filelist
for d in %{libdir_} %{bindir_} %{mandir_} %{infodir_}
do
  case $d in
    %{libdir_}/*) ;;
    %{bindir_}/*) ;;
    %{mandir_}/*) ;;
    %{infodir_}/*) ;;
    %{infodir_} | %{mandir_})
       find $RPM_BUILD_ROOT$d ! -type d -print \
        | sed -e "s@^$RPM_BUILD_ROOT@@g" >> $RPM_BUILD_DIR/%{pkg0}/%{pkg0}-filelist;;
    *) echo $d >> $RPM_BUILD_DIR/%{pkg0}/%{pkg0}-filelist ;;
  esac
done


%clean
rm -rf $RPM_BUILD_ROOT

# Whoops! Can't use paths here.
%files -f %{pkg0}-filelist
%defattr(-,root,root)
%doc NEWS README
%docdir %{mandir_}
%docdir %{infodir_}

# Install info entries in the "directory" files.
%post
for f in %{infodir_}/*-cris.info
do
  %{installinfo_} $f %{infodir_}/dir
done

# Install info entries from the "directory" files.
%preun
if [ $1 = 0 ]; then
  for f in %{infodir_}/*-cris.info
  do
    %{installinfo_} --delete $f %{infodir_}/dir
  done
fi
