/* Configuration for GNU C-compiler for CRIS.
   Copyright (C) 2000 Free Software Foundation, Inc.
   Contributed by Axis Communications AB.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

/* After this comment lies all defined preprocessor directives and attached
   declarations in the same order as found in the "Config" node ("The
   Configuration File" chapter) in the info files (the "Using and Porting
   GNU CC" manual) as of 2000-08-30.  Macros that are not defined are not
   here, and only CRIS-specific comments are here; see the manual for
   documentation about what the macro is for.

   Note that the CRIS port is not currently self-hosted so this file is
   never used in real life.  */

#define FATAL_EXIT_CODE 33
#define SUCCESS_EXIT_CODE 0

#define HOST_BITS_PER_CHAR 8
#define HOST_BITS_PER_SHORT 16
#define HOST_BITS_PER_INT 32
#define HOST_BITS_PER_LONG 32

/* When we get self-hosted, this will come from config/xm-linux.h.  */
#undef POSIX
#define POSIX

/* End of documented macros. */

/* Target machine dependencies.
   tm.h is a symbolic link to the actual target specific file.   */
#include "tm.h"
