# We can't do with subdir checking and substitutions in shell
# substitutions like "FOO = `case ... esac`" only.  I see no other way
# than to require GNU make.

ifneq (,)
This makefile fragment requires GNU Make.
endif

# Add linux settings for -mlinux multilibs, iff we have glibc reachable.
ifeq ($(findstring /linux,$(MULTISUBDIR)),/linux)
g_config_h_present := $(shell echo '\#include <_G_config.h>' | $(CC) -E $(CFLAGS) -pipe - > /dev/null 2>&1 && echo YES)
ifeq ($(findstring YES,$(g_config_h_present)),YES)
include $(srcdir)/config/mtsafe.mt
include $(srcdir)/config/linux.mt
# Some necessary pthread declarations aren't visible by default.
MT_CFLAGS += -D_GNU_SOURCE
# Fake in a few definitions which seem lost in glibc 2.2.x but necessary
# in the libio-referring-to-other-libio-version-which-has-the-same-API swamp.
MT_CFLAGS += -D_IO_stdin_=_IO_2_1_stdin_ -D_IO_stdout_=_IO_2_1_stdout_ -D_IO_stderr_=_IO_2_1_stderr_
endif
endif
